#ifdef TIFF_TYPE_LOOKUP
#undef TIFF_TYPE
#define TIFF_TYPE(NAME, ID, VALUE) [VALUE] = NAME,
#else
#undef TIFF_TYPE
#define TIFF_TYPE(NAME, ID, VALUE) ID = VALUE,
#endif /* ifdef TIFF_TYPE_LOOKUP */

TIFF_TYPE("UNSIGNED BYTE"    , TIFF_ENTRY_BYTE      , 0x0001) // 8-bit unsigned integer
TIFF_TYPE("ASCII"            , TIFF_ENTRY_ASCII     , 0x0002) // 8-bit byte that contains a 7-bit ASCII code; the last byte must be NUL (binary zero)
TIFF_TYPE("UNSIGNED SHORT"   , TIFF_ENTRY_SHORT     , 0x0003) // 16-bit (2-byte) unsigned integer
TIFF_TYPE("UNSIGNED LONG"    , TIFF_ENTRY_LONG      , 0x0004) // 32-bit (4-byte) unsigned integer
TIFF_TYPE("UNSIGNED RATIONAL", TIFF_ENTRY_RATIONAL  , 0x0005) // Two LONGs: the first represents the numerator of a fraction; the second, the denominator
TIFF_TYPE("SIGNED BYTE"      , TIFF_ENTRY_SBYTE     , 0x0006) // An 8-bit signed (twos-complement) integer
TIFF_TYPE("UNDEFINED"        , TIFF_ENTRY_UNDEFINED , 0x0007) // An 8-bit byte that may contain anything, depending on the definition of the field
TIFF_TYPE("SIGNED SHORT"     , TIFF_ENTRY_SSHORT    , 0x0008) // A 16-bit (2-byte) signed (twos-complement) integer
TIFF_TYPE("SIGNED LONG"      , TIFF_ENTRY_SLONG     , 0x0009) // A 32-bit (4-byte) signed (twos-complement) integer
TIFF_TYPE("SIGNED RATIONAL"  , TIFF_ENTRY_SRATIONAL , 0x000a) // Two SLONG’s: the first represents the numerator of a fraction, the second the denominator
TIFF_TYPE("FLOAT"            , TIFF_ENTRY_FLOAT     , 0x000b) // Single precision (4-byte) IEEE format
TIFF_TYPE("DOUBLE"           , TIFF_ENTRY_DOUBLE    , 0x000c) // Double precision (8-byte) IEEE format
